/*
 * Julien Hatin
 * Pierre LEGER
 * gcc openCV.c `pkg-config --cflags --libs opencv`
 */

#include <stdio.h>
#include "highgui.h"
#define TRIGGER 1000000

IplImage * substract(IplImage* img, IplImage* img2) {
	//On suppose que les images img et img2 sont initialisées, même dimension, même profondeur...
	int i;
	int j;
	int k;

	//On initialise l'image 3
	IplImage *img3 = cvCreateImage(cvGetSize(img), img->depth, img->nChannels);

	//On initialise 3 scalaires pour contenir les pixels.
	CvScalar scalaire, scalaire2, scalaire3;

	//On initialise le scalaire3 pour éviter les erreurs
	scalaire3=cvScalar(0, 0, 0, 0);

	//    [...] puis plus tard dans la boucle...

	//Maintenant on parcourt les images pour faire la soustraction
	for(i=0; i<img->width; i++){
		for(j=0; j<img->height; j++){

			//Attention une image est une matrice, on donne "l'ordonnée"
			//avant "l'abscisse"...
			scalaire=cvGet2D(img, j, i);
			scalaire2=cvGet2D(img2, j, i);

			//On fait la soustraction, mais on fait attention aux valeurs
			//négatives : en gros, on calcule la valeur absolue 
			//de la différence.

			for(k=0; k<img->nChannels; k++){
				scalaire3.val[k]=abs(scalaire.val[k]-scalaire2.val[k]);
			}

			//On place le résultat dans l'img3
			cvSet2D(img3, j, i, scalaire3);
		}
	}
	return img3;
}

int count(IplImage* img) {
	//On suppose que les images img et img2 sont initialisées, même dimension, même profondeur...
	int i;
	int j;
	int k;
	int count = 0;

	//On initialise 3 scalaires pour contenir les pixels.
	CvScalar scalaire;

	//    [...] puis plus tard dans la boucle...

	//Maintenant on parcourt les images pour faire la soustraction
	for(i=0; i<img->width; i++){
		for(j=0; j<img->height; j++){

			//Attention une image est une matrice, on donne "l'ordonnée"
			//avant "l'abscisse"...
			scalaire=cvGet2D(img, j, i);

			//On fait la soustraction, mais on fait attention aux valeurs
			//négatives : en gros, on calcule la valeur absolue 
			//de la différence.

			for(k=0; k<img->nChannels; k++){
				count +=	scalaire.val[k];
			}

		}
	}
	return count;
}


int main(int argc, char **argv) {


	system("echo \"17\" > /sys/class/gpio/export");
	system("echo \"out\" > /sys/class/gpio/gpio17/direction");
	system("echo \"0\" > /sys/class/gpio/gpio17/value");

	// Touche clavier
	char key;
	// Image
	IplImage *image1=NULL;
	IplImage *image2=NULL;
	IplImage *subImage=NULL;
	// Capture vidéo
	CvCapture *capture;

	// Ouvrir le flux vidéo
	capture = cvCreateCameraCapture(atoi(argv[1]));

	cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH, 640);
	cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT, 480);
	cvSetCaptureProperty(capture, CV_CAP_PROP_BRIGHTNESS, 0.65);


	printf("Enjoy !");
	// Vérifier si l'ouverture du flux est ok
	if (!capture) {
		printf("Ouverture du flux vidéo impossible !\n");
		return 1;
	}

	system("echo \"1\" > /sys/class/gpio/gpio17/value");
	sleep(1);
	system("echo \"0\" > /sys/class/gpio/gpio17/value");

	sleep(1);

	system("echo \"1\" > /sys/class/gpio/gpio17/value");
	sleep(1);
	system("echo \"0\" > /sys/class/gpio/gpio17/value");
	
	int i = 0;
	while(1) {
		printf("Passage de boucle %d\n", i);
		i++;

		// On récupère une image a 500ms d'intervalle
		image1 = cvQueryFrame(capture);
		// On attend 1s
		cvWaitKey(50);
		cvSaveImage("buffer1.jpg",image1,0);
		image2 = cvQueryFrame(capture);

		//On soustraitn les deux images afin d'obtenir la difference.

		// On affiche les images dans des fenêtres
		cvSaveImage("buffer2.jpg",image2,0);

		image1 = cvLoadImage("buffer1.jpg", CV_LOAD_IMAGE_GRAYSCALE);
		image2 = cvLoadImage("buffer2.jpg", CV_LOAD_IMAGE_GRAYSCALE);

		subImage = substract(image1, image2);

		int trigger = count(subImage);
		printf("trigger : %d\n", trigger);
		if(trigger > TRIGGER) {	
			system("echo \"1\" > /sys/class/gpio/gpio17/value");
			sleep(10);
			system("echo \"0\" > /sys/class/gpio/gpio17/value");
		}

	}
	cvReleaseCapture(&capture);
	return 0;
}

